CREATE TABLE `reports` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `file_name` varchar(70) NOT NULL,
  `descr` varchar(250) DEFAULT NULL,
  `with_params` tinyint(1) DEFAULT NULL,
  `report` mediumblob NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE `report_params` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `varName` varchar(50) NOT NULL,
  `regex` varchar(50) DEFAULT NULL,
  `regexMes` varchar(250) DEFAULT NULL,
  `valueExpr` varchar(250) DEFAULT NULL,
  `wrapValues` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE `reports_params` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `reportId` int(10) NOT NULL,
  `paramId` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

INSERT INTO `report_params`  VALUES (null,'Курс','courseNum','\\d','Курс должен быть целой положительной цифрой',NULL,NULL);
INSERT INTO `report_params`  VALUES (null,'Группа','groupNum','\\d{1,2}','Группа должна быть целым положительным числом',NULL,NULL);
INSERT INTO `report_params`  VALUES (null,'Ученая степень','degree',NULL,NULL,'select distinct degree from grades group by id',1);
INSERT INTO `report_params`  VALUES (null,'Ид. дисциплины','disciplineId','\\d+','\\d+',NULL,0);
INSERT INTO `report_params`  VALUES (null,'Ид. группы','groupId','\\d+','\\d+',NULL,0);
INSERT INTO `report_params`  VALUES (null,'Ид.семестра','semId','\\d+','\\d+',NULL,0);
INSERT INTO `report_params`  VALUES (null,'Послеэкз. признак','isAfterExam','[01]','[01]',NULL,0);

CREATE TABLE `text_mark` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

insert into text_mark values(1, 'недопуск');
insert into text_mark values(2, 'неуд.');
insert into text_mark values(3, 'удовл.');
insert into text_mark values(4, 'хорошо');
insert into text_mark values(5, 'отлично');
insert into text_mark values(6, 'незачет');
insert into text_mark values(7, 'зачет');

DELIMITER //
CREATE FUNCTION `GetTextMark`(isAfterExam char(1), examType varchar(20), rate INT) RETURNS varchar(100) CHARSET utf8
    NO SQL
BEGIN
	declare markTextId int;
    declare markText varchar(100) charset utf8;
    if examType = 'credit' then
        if rate < 60 then
			set markTextId = 6;#незачет
		else 
			set markTextId = 7;#зачет
		end if;
    elseif examType = 'gradingcredit' then
		if rate >= 85 then 
			set markTextId = 5;#неуд.
		elseif rate >= 70 then 
			set markTextId = 4;#хорошо
		elseif rate >= 60 then
			set markTextId = 3;#удовл.
		else
			set markTextId = 2;#неуд.
		end if;
    elseif isAfterExam = '0' then
		if rate < 38 then
			set markTextId = 1;#недопуск
		else
			return "";
		end if;
	else
		if rate >= 85 then 
			set markTextId = 5;#неуд.
		elseif rate >= 70 then 
			set markTextId = 4;#хорошо
		elseif rate >= 60 then
			set markTextId = 3;#удовл.
		else
			set markTextId = 2;#неуд.
		end if;
	end if;
    select name from text_mark where id = markTextId into markText;
    return markText;
END//
DELIMITER ;